%This script allow  you to calculate and visualize the fourier's series of generic f(x)function
%The script it's very simple. Set the domain estention  choosing the "a" value; after
%that set the series's order 'n' and than chose your f(x) "f_x". The series will be
%calculated and represented  in 3 ways: S_standard , S_armonic, S_complex. 

%***********************************
%created by:Riccardo Dess
%e-mail: ri.dessi1@studenti.unica.it
%***********************************


a=pi; %kind of domain [-a,a]
n=10; %series order approssimation
pass=0.01; %integrazion step
x=(-a:pass:a);  %building domain
f_x=(x);  %f(x) other samples input f_x=x.^2, f_x=cos(x) 


a0=(1/(2*a).*sum(f_x));
c=2*a/pass+1;
ak=zeros(n,c);
bk=zeros(n,c);
armonica=zeros(n,c);
complessa=zeros(n,c);

for k=1:n
aa=(1/a.*sum((f_x).*(cos(k*pi/a*x))));
ak(k,:)=aa.*cos((k*pi/a)*x);
bb=(1/a.*sum((f_x).*(sin(k*pi/a*x))));
bk(k,:)=bb.*sin((k*pi/a)*x);
c1=0.5*(aa-bb*1i);
c2=0.5*(aa+bb*1i);
complessa(k,:)=c1*exp(1i*k*(pi/a).*x)+c2*exp(-1i*k*(pi/a).*x);

    if (aa>0) %#ok<BDSCI>
    armonica(k,:)=sqrt(aa^2+bb^2).*cos((k*(pi/a)).*x+atan(-bb/aa));
    else
    armonica(k,:)=sqrt(aa^2+bb^2).*cos((k*(pi/a)).*x+atan(-bb/aa)+pi);
    end
end

ak=sum(ak(1:end,:));
bk=sum(bk(1:end,:));
S_standard=((a0+(ak+bk)).*pass);
S_armonic=(a0+sum(armonica(1:end,:))).*pass;
S_complex=(a0+sum(complessa(1:end,:))).*pass;

subplot(1,3,1)
plot(x,f_x,x,S_standard,'-')
title('Standard representation')
legend('f(x)','S-standard')

subplot(1,3,2)
plot(x,f_x,x,S_armonic,'-')
title('Armonic representation')
legend('f(x)','S-armonic')

subplot(1,3,3)
plot(x,f_x,x,S_complex,'-')
title('Complex representation')
legend('f(x)','S-complex')
